"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.handler = exports.desc = exports.command = void 0;

var _chalk = _interopRequireDefault(require("chalk"));

var _graphqlConfig = require("graphql-config");

var _util = require("./util");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

// Plugin boilerplate
const command = 'maddheaders [--project]';
exports.command = command;
const desc = 'Add required Maana headers to your project(s)';
exports.desc = desc;

const handler = /*#__PURE__*/function () {
  var _ref = _asyncToGenerator(function* (context, argv) {
    // get the full config file information
    let fullConfig = (0, _graphqlConfig.getGraphQLConfig)();
    let config = fullConfig.config; // if the user specified a specific project, we only want to edit the config
    // for that project

    if (argv.project) {
      if (config.projects && config.projects[argv.project]) {
        config = config.projects[argv.project];
      } else {
        console.log(_chalk.default.red(`✘ Failed to find the project ${argv.project}`));

        if (config.projects && Object.keys(config.projects).length > 0) {
          console.log(_chalk.default.yellow('Did you mean one of:'), _chalk.default.green(Object.keys(config.projects).join(', ')));
        } else {
          console.log(_chalk.default.yellow('Run'), _chalk.default.green('graphql add-project'), _chalk.default.yellow('to add a project to the .graphqlconfig'));
        }

        return;
      }
    }

    (0, _util.addHeadersToConfig)(config);
    fullConfig.saveConfig(fullConfig.config);
    console.log(_chalk.default.green('✔ Successfully added the headers'));
  });

  return function handler(_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();

exports.handler = handler;